module TEO
  class Image
    def force_put_color(x,y,c)
	begin
	  self[x,y]=c
	rescue
	  nil
	end
    end
    def force_get_color(x,y)
      begin
	self[x,y]
      rescue
	0
      end
    end
    def drawrect(x1,y1,x2,y2,color,fill=false,broken=nil)
      if fill
	for y in y1..y2
	  for x in x1..x2
	    force_put_color(x,y,color)
	  end
	end
      else
	d = true
	c = 0
	for x in x1..x2
	  force_put_color(x,y1,color) if d
	  force_put_color(x,y2,color) if d
	  if broken!=nil
	    then
	    c += 1
	    if c >= broken
	    then
	      d = !d
	      c = 0
	    end
	  end
	end
	for y in y1..y2
	  force_put_color(x1,y,color) if d
	  force_put_color(x2,y,color) if d
	  if broken!=nil
	    then
	    c += 1
	    if c >= broken
	    then
	      d = !d
	      c = 0
	    end
	  end
	end
      end
    end

    def drawline(x1,y1,x2,y2,color,fill=false,broken=nil)
      x=x1
      y=y1
      dx = if(x1>x2)
	     -1 
	   elsif(x1<x2)
	     1
	   else
	     0 
	   end
      dy = if(y1>y2) 
	     -1
	   elsif(y1<y2)
	     1 
	   else
	     0
	   end

      d = true
      c = 0
      while(x!=x2 or y!= y2)
	self[x,y]=color if d
	if broken!=nil
	then
	  c += 1
	  if c >= broken
	  then
	    d = !d
	    c = 0
	  end
	end

	nx = x+dx
	ny = y+dy
	if( ((y2-y1)*(nx-x1)-(x2-x1)*(y-y1)).abs<
	   ((y2-y1)*(x-x1)-(x2-x1)*(ny-y1)).abs )
	  x=nx
	elsif( ((y2-y1)*(nx-x1)-(x2-x1)*(y-y1)).abs >
	    ((y2-y1)*(x-x1)-(x2-x1)*(ny-y1)).abs )
	  y=ny
	else
	  x=nx
	  y=ny
	end
      end
    end

    def drawarc(cx,cy,w,h,color,fill=false)
      ww=w*w
      hh=h*h
      wh=ww*hh
      if(fill)
	for y in 0..h
	  wx = Math.sqrt((wh - ww*y*y)/hh)
	  for x in 0..wx
	    force_put_color(cx+x,cy+y,color)
	    force_put_color(cx+x,cy-y,color)
	    force_put_color(cx-x,cy-y,color)
	    force_put_color(cx-x,cy+y,color)
	  end
	end
      else
	x = w
	y = 0
	while(x>=0)
	  force_put_color(cx+x,cy+y,color)
	  force_put_color(cx+x,cy-y,color)
	  force_put_color(cx-x,cy-y,color)
	  force_put_color(cx-x,cy+y,color)
	  if( (hh*(x-1)*(x-1) + ww*y*y - wh).abs <=
	     (hh*x*x + ww*(y+1)*(y+1) - wh).abs )
	    x=x-1
	  else
	    y=y+1
	  end
	end
      end
    end
    
  end

end
